/** ============================================================
 ** init.c
 ------------------------------------------------------------
 ** Role .......... : Initiation du system
 ** Auteur ........ : Loc Lt
 ** Mise  jour ... : 16/12/2017
 ===============================================================
 ** Note du Fichier :
 ---------------------------------------------------------------


 =============================================================== **/

// ----------------------
// * Fichier d'include
// ----------------------
#include "header/main.h"


// --------------------------------------------------------------
// * inir_system_game()
//     Initation du systme megadrive
// --------------------------------------------------------------
void init_system_game()
{

    // **********************************
    // ** Gestion de l'cran megadrive **
    // **********************************
    // * Compatibilit NTSC et PAL      *
    // * Mode 256/224 pixel             *
    // * 16*14 tiles de 16px            *
    // * 32*28 tiles de 8px (native)    *
    // **********************************

    VDP_setPlanSize	(64,32);

    VDP_setScreenWidth256();
    VDP_setScreenHeight224();

    // *****************************
    // ** Initiation du scrolling **
    // *****************************
    // * Mode pixel par Pixel      *
    // *****************************

    VDP_setScrollingMode(HSCROLL_PLANE, VSCROLL_PLANE);

    // *************************************
    // ** Donne provisoir pour les tests **
    // *************************************
    // * A virrer bien sur non d'une       *
    // *************************************

const u16 PalletteExport[16] = {
	0x0000,0x0888,0x0EEE,0x020A,0x086C,0x0224,0x0048,0x028E,	//  Pallette: 0
	0x06EE,0x0442,0x0062,0x00AA,0x0220,0x0840,0x0E82,0x0EC0,
	} ;

	const u32 tile[64]=
    {

		0x11111111,
		0x10000000,
		0x10000000,
		0x10000000,
		0x10000000,
		0x10000000,
		0x10000000,
		0x10000000,

		0x11111111,
		0x00000001,
		0x00000001,
		0x00000001,
		0x00000001,
		0x00000001,
		0x00000001,
		0x00000001,


		0x10000000,
		0x10000000,
		0x10000000,
		0x10000000,
		0x10000000,
		0x10000000,
		0x10000000,
		0x11111111,

		0x00000001,
        0x00000001,
		0x00000001,
		0x00000001,
		0x00000001,
		0x00000001,
		0x00000001,
        0x11111111,

        0x33333333,
		0x30000000,
		0x30000000,
		0x30000000,
		0x30000000,
		0x30000000,
		0x30000000,
		0x30000000,

		0x33333333,
		0x00000003,
		0x00000003,
		0x00000003,
		0x00000003,
		0x00000003,
		0x00000003,
		0x00000003,


		0x30000000,
		0x30000000,
		0x30000000,
		0x30000000,
		0x30000000,
		0x30000000,
		0x30000000,
		0x33333333,

		0x00000003,
        0x00000003,
		0x00000003,
		0x00000003,
		0x00000003,
		0x00000003,
		0x00000003,
        0x33333333


    };

   // Charge un tableau pour la palette
 VDP_setPaletteColors(0, (u16*) PalletteExport, 16);

// Charge un tableau dans la mmoire vido en tant que "tiles".
//
VDP_loadTileData( (const u32 *)tile, 1, 8, 0);


}
