/** ============================================================
 ** input.c
 ------------------------------------------------------------
 ** Role .......... : Gestion de la manette de jeu
 ** Auteur ........ : Loc Lt
 ** Mise  jour ... : 16/12/2017
 ** Version ....... : 1.0.0
 ===============================================================
 ** Note du Fichier :
 ---------------------------------------------------------------
 *

 =============================================================== **/


// ----------------------
// * Fichier d'include
// ----------------------
#include "header/main.h"

// ------------------------------------------------------------------
// * get_input() : Version 1.0.0
//     Permet de rcuprer les donnes du 1er joystick de la mgadrive
//
// ------------------------------------------------------------------

void get_input(u8 *p_Direction,u8 *p_Bouton_A,u8 *p_Bouton_B,u8 *p_Bouton_C,u8 *p_Bouton_START)
{

    // *****************************
    // ** Gestion de la direction **
    // *****************************
    // * Haut.... : 8
    // * Bas..... : 2
    // * Droite.. : 6
    // * Gauche.. : 4
    // *****************************

     if (JOY_readJoypad(JOY_1) & (BUTTON_UP))
    {

         *p_Direction = 8;
    }
    else if (JOY_readJoypad(JOY_1) & (BUTTON_DOWN))
    {

         *p_Direction = 2;
    }
    else if (JOY_readJoypad(JOY_1) & (BUTTON_LEFT))
    {

         *p_Direction = 4;
    }
    else if (JOY_readJoypad(JOY_1) & (BUTTON_RIGHT))
    {

        *p_Direction = 6;

    }
    else
    {

        *p_Direction = 0;
    }


    // *************************
    // ** Gestion du Bouton A **
    // *************************

    if (JOY_readJoypad(JOY_1) & (BUTTON_A))
    {

       *p_Bouton_A = 1;
    }
    else
    {
       *p_Bouton_A = 0;
    }

    // *************************
    // ** Gestion du Bouton B **
    // *************************

    if (JOY_readJoypad(JOY_1) & (BUTTON_B))
    {

       *p_Bouton_B = 1;
    }
    else
    {

       *p_Bouton_B = 0;
    }


    // *************************
    // ** Gestion du Bouton C **
    // *************************

    if (JOY_readJoypad(JOY_1) & (BUTTON_C))
    {

        *p_Bouton_C = 1;
    }
    else
    {

        *p_Bouton_C = 0;
    }


    // *****************************
    // ** Gestion du Bouton Start **
    // *****************************

    if (JOY_readJoypad(JOY_1) & (BUTTON_START))
    {

        *p_Bouton_START = 1;
    }
    else
    {

        *p_Bouton_START = 0;
    }


}

