
/** ============================================================
 ** Nom du Projet ........ : Hero Fantasy III
 ** Date initiation ...... : 16/12/2017
 ** Version du projet .... : 1.0.0
 ** Date de sauvegarde ... : 17/12/2017
 ** Deployement .......... : En programmation
 ** Licence .............. : Propritaire
 ** Compilation Megadrive..: SGDK
 ** ============================================================
 ** Auteur ............... : Loc Lt
 ** Programmation ........ : Loc Lt
 ** Graphismes ........... :
 ** Musique .............. :
 ** SGDK Megadrive ....... : Stephane Dallongeville
 **                        : Krikzz
 **                        : Chilly Willy
 **                        : Kaneda
 **                        : Paspallas Dev
 **                        : Jack Nolddor
 **                        : Alone Coder and Shiru

 ** ============================================================
 ** main.c
 ---------------------------------------------------------------
 ** Role .......... : Fichier Principale du programme
 ** Auteur ........ : Loc Lt
 ** Mise  jour ... : 17/12/2017
 ===============================================================
 ** Note du Fichier :
 ---------------------------------------------------------------
 * La programmation du fichier main doivent tre gnrique.

 =============================================================== **/


// ----------------------
// * Fichier d'include
// ----------------------

#include "header/main.h"

// -----------------------------------
// * main()
//     la fonction main du programme
// -----------------------------------
int main()
{

    // ----------------------------
    // * Dclaration des variables
    // ----------------------------
    u8 direction;
    u8 bouton_A;
    u8 bouton_B;
    u8 bouton_C;
    u8 bouton_START;

    u8 x_offset;
    u8 y_offset;
    u8 cycle;

    // ------------------------
    // * Initiation de dpart
    // ------------------------
    scene_set(SCENE_INIT);

    // ----------------------
    // * Boucle du programme
    // ----------------------

    while(1) // Attention boucle infini  !!!
    {

        // -------------------------
        // * SCENE_INIT
        // -------------------------
        if ( scene_get() == SCENE_INIT )
        {
            init_system_game();
            scene_set(SCENE_TITLESCREEN);
            Wait_VBL();

        }

        // ------------------------
        // * SCENE_TITLESCREEN
        // ------------------------
        else if ( scene_get() == SCENE_TITLESCREEN )
        {

            while ( scene_get() == SCENE_TITLESCREEN )
            {

                scene_set(SCENE_MAP); // Test
                Wait_VBL();
            }
        }

        // ------------------------
        // * SCENE_MAP
        // ------------------------
        else if (scene_get()==SCENE_MAP)
        {

            // ******************************
            // ** Affichage d'une map test **
            // ******************************
            draw_map_start();


             while( scene_get() == SCENE_MAP )
            {

                get_input(&direction,&bouton_A,&bouton_B,&bouton_C,&bouton_START);



                // ************************
                // ** Dplacement Gauche **
                // ************************


                if (direction == 4)
                {


                    draw_left_map(x_offset,y_offset);

                    x_offset--;

                    for (cycle=1;cycle<17;cycle++)
                    {

                        VDP_setHorizontalScroll(PLAN_A,-x_offset * 16 - 16 + cycle);
                        Wait_VBL();
                    }


                }


                // ************************
                // ** Dplacement Droite **
                // ************************

                if (direction == 6)
                {
                    draw_right_map(x_offset,y_offset);
                    x_offset++;

                    for (cycle=1;cycle<17;cycle++)
                    {
                        VDP_setHorizontalScroll(PLAN_A,-x_offset * 16 + 16 - cycle);
                        Wait_VBL();
                    }

                }



                // **********************
                // ** Dplacement Haut **
                // **********************
                 if (direction == 8)
                {

                    draw_up_map(x_offset,y_offset);
                    y_offset--;

                    for (cycle=1;cycle<17;cycle++)
                    {
                        VDP_setVerticalScroll(PLAN_A,-y_offset * 16 + 16 - cycle);
                        Wait_VBL();
                    }


                }


                // **********************
                // ** Dplacement Bas **
                // *********************

                if (direction == 2)
                {
                    draw_down_map(x_offset,y_offset);
                    y_offset++;

                    for (cycle=1;cycle<17;cycle++)
                    {
                     VDP_setVerticalScroll(PLAN_A, -y_offset * 16 + 16 + cycle);
                     Wait_VBL();
                    }


                }

                Wait_VBL();
            }

        }




        Wait_VBL();
    }

    return (0);
}




/** ============================================================
 **                     Historique du projet
 ** ------------------------------------------------------------
 ** 17/12/2017 : 1er jet du scrolling fluide pixel
 ** 16/12/2017 : Dbut officiel du projet
 ** =============================================================**/




